services:
  keycloak:
    image: quay.io/keycloak/keycloak
    environment:
      - KEYCLOAK_ADMIN=admin
      - KEYCLOAK_ADMIN_PASSWORD=admin
    ports:
      - 127.0.0.1:28080:8080
    command: start-dev
  service-a:
    image: python_oauth_example
    build:
      dockerfile: Dockerfile
      context: .
      target: app
    entrypoint: poetry run gunicorn main:get_app -w 4 -k aiohttp.GunicornWebWorker --bind :8080
    environment:
      SERVICE_OAUTH_URL: "http://keycloak:8080/"
      SERVICE_NAME: "service-a"
      SERVICE_NEIGHBOR_HOST: "http://service-b:8080"
      SERVICE_OAUTH_CLIENT_ID: "service-a"
      SERVICE_OAUTH_CLIENT_SECRET: "service-a-secret"
      SERVICE_OAUTH_CLIENT_REALM: "TestRealm"
    ports:
      - 127.0.0.1:28081:8080
    volumes:
      - "./oauth_example/:/opt/oauth_example/"
  service-b:
    image: python_oauth_example
    build:
      dockerfile: Dockerfile
      context: .
      target: app
    entrypoint: poetry run gunicorn main:get_app -w 4 -k aiohttp.GunicornWebWorker --bind :8080
    environment:
      SERVICE_OAUTH_URL: "http://keycloak:8080/"
      SERVICE_NAME: "service-b"
      SERVICE_NEIGHBOR_HOST: "http://service-a:8080"
      SERVICE_OAUTH_CLIENT_ID: "service-b"
      SERVICE_OAUTH_CLIENT_SECRET: "service-a-secret"
      SERVICE_OAUTH_CLIENT_REALM: "TestRealm"
    volumes:
      - "./oauth_example/:/opt/oauth_example/"
